/*
  This code is released under the Antivirial License.

  http://www.ecstaticlyrics.com/antiviral/

  The only condition of the license is that you may not change the license
  terms.  Because of this, you may *not* include this code in GPL-licensed
  projects, as the GPL requires that the entire project be GPL-licensed.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "buffer.h"
#include "easy.h"
#include "error.h"
#include "memory.h"
#include "thread.h"

#include "glfw.h"
#include "user.h"
#include "alsa.h"
#include "radio.h"
#include "network.h"
#include "option.h"

volatile int main_exit_flag = 0;

int main (int argc, char **argv) {
  memory_initialize();

  chdir(getenv("HOME"));
  mkdir(".config", 0777);
  mkdir(".config/natpos", 0777);
  chdir(".config/natpos");

  option_parse(argc, argv);
  network_initialize();
  glfw_initialize();
  user_initialize();
  radio_initialize();
  alsa_initialize();
  user_interface();
  alsa_terminate();
  radio_terminate();
  user_terminate();
  glfw_terminate();
  network_terminate();

  memory_terminate();
};
