void radio_initialize();
void radio_terminate();
void radio_demodulate (float *output, int count);
void radio_set_time_offset (int offset);
void radio_get_playback_position (float *x, float *y);
void radio_set_squelch();
void radio_start_recording();
void radio_stop_recording();
void radio_start_iq_recording();

volatile int radio_mode;
volatile int radio_time_offset;
volatile int radio_demodulator_enable;
volatile int radio_test_flag;
volatile float radio_carrier_frequency_offset;
volatile float radio_signal_strength_squared;
volatile float radio_iq_strength_squared;
volatile float radio_audio_gain;
volatile int radio_scan_enable;
volatile int radio_invert_audio;

volatile int radio_channel_bandwidth;
volatile int radio_audio_bandwidth;

float radio_post_fm_frequency_shift;

struct radio_state {

  int mode;
  int offset_frequency;
  int upconverter_frequency;

  // controlled via rtl_tcp:
  int center_frequency; // 0x01
  int sample_rate;      // 0x02
  int gain_mode;        // 0x03
  int agc_mode;         // 0x08
  int direct_sampling;  // 0x09
  int gain_index;       // 0x0d

};

volatile struct radio_state radio_state;

#define RADIO_MODE_AM_10 1
#define RADIO_MODE_FM_12 2
#define RADIO_MODE_FM_25 3
#define RADIO_MODE_USB 4
#define RADIO_MODE_LSB 5
#define RADIO_MODE_FM_200 6
