/*
  This code is released under the Antivirial License.

  http://www.ecstaticlyrics.com/antiviral/

  The only condition of the license is that you may not change the license
  terms.  Because of this, you may *not* include this code in GPL-licensed
  projects, as the GPL requires that the entire project be GPL-licensed.
*/

#ifndef THREAD_H
#define THREAD_H

#include <pthread.h>

#ifdef WINDOWS
  #undef WINDOWS
  #define WINDOWS 1
#endif

#ifdef TEST
  #undef TEST
  #define TEST 1
#endif

#ifdef WINDOWS
  #define MUTEX HANDLE
  #define MUTEX_INIT(i) if (NULL == (i = CreateSemaphore(NULL, 1, 1, NULL))) { printf("GetLastError() = %d\n", GetLastError()); easy_fuck("Failed to create semaphore!"); };
  #define MUTEX_LOCK(i) if (WAIT_OBJECT_0 != WaitForSingleObject(i, INFINITE)) { printf("GetLastError() = %d\n", GetLastError()); easy_fuck("Failed to WaitForSingleObject!"); };
  #define MUTEX_UNLOCK(i) if (!ReleaseSemaphore(i, 1, NULL)) { printf("GetLastError() = %d\n", GetLastError()); easy_fuck("Failed to release semaphore!"); };
#else
  #define MUTEX pthread_mutex_t
  #define MUTEX_INIT(i) pthread_mutex_init(&i, NULL)
  #define MUTEX_LOCK(i) pthread_mutex_lock(&i)
  #define MUTEX_UNLOCK(i) pthread_mutex_unlock(&i)
#endif

#if WINDOWS || TEST
  typedef struct rw_lock {
    MUTEX change;
    MUTEX in_use;
    int count;
  } RWLOCK;
  void thread_lock_init(struct rw_lock *rwlock);
  void thread_lock_read(struct rw_lock *rwlock);
  void thread_unlock_read(struct rw_lock *rwlock);
  void thread_lock_write(struct rw_lock *rwlock);
  void thread_unlock_write(struct rw_lock *rwlock);
#else
  #define RWLOCK pthread_rwlock_t
  #define thread_lock_init(x) pthread_rwlock_init(x, NULL);
  #define thread_lock_read(x) pthread_rwlock_rdlock(x);
  #define thread_lock_write(x) pthread_rwlock_wrlock(x);
  #define thread_unlock_read(x) pthread_rwlock_unlock(x);
  #define thread_unlock_write(x) pthread_rwlock_unlock(x);
#endif

void thread_priority_background();
void thread_create(void (*function(void *)), void *parameter);
void thread_exit();

#endif
